#include <propeller.h>

int baudticks;
int txmask;

// Terminal

__attribute__((fcache))
void tx(int val)
 // fast serial TX routine, executes from cache
{
  int bitm, tm;
  val = (val ^ 0x300)<<1;   //add start + 2 stopbits
  tm = CNT + baudticks;
  for(bitm=1; bitm<0x800; bitm<<=1) {
    if(val & bitm) OUTA |= txmask;
    else OUTA &= ~txmask;
    tm = waitcnt2(tm, baudticks);
  }
}

void dec(int value)
 // display dec value on terminal
{
  int c, d=1000000000;
  if(value < 0) {tx('-'); value = -value;}
  while(d > value) d /= 10;
  if(d==0) tx('0');
  while(d > 0) {
      c = (value / d) % 10;
      tx(c + '0');
      d /= 10;
  }
}

// Fibo

int fibo (int n)
{
    if (n < 2)
        return (n);
    else
        return fibo(n - 1) + fibo(n - 2);
}

int main()
{
  int t;

  txmask = 1<<30;   // out-pin
  baudticks = CLKFREQ / 115200;   //baudrate
  OUTA |= txmask;
  DIRA |= txmask;

  t = CNT;
  fibo(26);
  t = CNT - t;   // time
  dec(t/80000);  // in ms

  while(1) ;
}
